/* display.c generated by valac 0.44.3, the Vala compiler
 * generated from display.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "common.h"
#include <stdlib.h>
#include <string.h>

#define BOXES_TYPE_IPROPERTIES_PROVIDER (boxes_iproperties_provider_get_type ())
#define BOXES_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProvider))
#define BOXES_IS_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER))
#define BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProviderIface))

typedef struct _BoxesIPropertiesProvider BoxesIPropertiesProvider;
typedef struct _BoxesIPropertiesProviderIface BoxesIPropertiesProviderIface;
typedef enum  {
	BOXES_PROPERTIES_PAGE_GENERAL,
	BOXES_PROPERTIES_PAGE_SYSTEM,
	BOXES_PROPERTIES_PAGE_DEVICES,
	BOXES_PROPERTIES_PAGE_SNAPSHOTS,
	BOXES_PROPERTIES_PAGE_LAST
} BoxesPropertiesPage;

#define BOXES_TYPE_PROPERTIES_PAGE (boxes_properties_page_get_type ())

#define BOXES_TYPE_PROPERTY (boxes_property_get_type ())
#define BOXES_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_PROPERTY, BoxesProperty))
#define BOXES_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_PROPERTY, BoxesPropertyClass))
#define BOXES_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_PROPERTY))
#define BOXES_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_PROPERTY))
#define BOXES_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_PROPERTY, BoxesPropertyClass))

typedef struct _BoxesProperty BoxesProperty;
typedef struct _BoxesPropertyClass BoxesPropertyClass;

#define BOXES_TYPE_DISPLAY (boxes_display_get_type ())
#define BOXES_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_DISPLAY, BoxesDisplay))
#define BOXES_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_DISPLAY, BoxesDisplayClass))
#define BOXES_IS_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_DISPLAY))
#define BOXES_IS_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_DISPLAY))
#define BOXES_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_DISPLAY, BoxesDisplayClass))

typedef struct _BoxesDisplay BoxesDisplay;
typedef struct _BoxesDisplayClass BoxesDisplayClass;
typedef struct _BoxesDisplayPrivate BoxesDisplayPrivate;
typedef gint (*BoxesDisplayOpenFDFunc) (gpointer user_data);
enum  {
	BOXES_DISPLAY_0_PROPERTY,
	BOXES_DISPLAY_PROTOCOL_PROPERTY,
	BOXES_DISPLAY_URI_PROPERTY,
	BOXES_DISPLAY_CAN_TRANSFER_FILES_PROPERTY,
	BOXES_DISPLAY_CONFIG_PROPERTY,
	BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY,
	BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY,
	BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY,
	BOXES_DISPLAY_NEED_PASSWORD_PROPERTY,
	BOXES_DISPLAY_NEED_USERNAME_PROPERTY,
	BOXES_DISPLAY_PASSWORD_PROPERTY,
	BOXES_DISPLAY_USERNAME_PROPERTY,
	BOXES_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* boxes_display_properties[BOXES_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	BOXES_DISPLAY_SHOW_SIGNAL,
	BOXES_DISPLAY_HIDE_SIGNAL,
	BOXES_DISPLAY_DISCONNECTED_SIGNAL,
	BOXES_DISPLAY_GOT_ERROR_SIGNAL,
	BOXES_DISPLAY_AUTH_FAILED_SIGNAL,
	BOXES_DISPLAY_NUM_SIGNALS
};
static guint boxes_display_signals[BOXES_DISPLAY_NUM_SIGNALS] = {0};

struct _BoxesIPropertiesProviderIface {
	GTypeInterface parent_iface;
	GList* (*get_properties) (BoxesIPropertiesProvider* self, BoxesPropertiesPage page);
};

struct _BoxesDisplay {
	GObject parent_instance;
	BoxesDisplayPrivate * priv;
	gboolean connected;
	GHashTable* displays;
};

struct _BoxesDisplayClass {
	GObjectClass parent_class;
	GtkWidget* (*get_display) (BoxesDisplay* self, gint n);
	GdkPixbuf* (*get_pixbuf) (BoxesDisplay* self, gint n, GError** error);
	void (*set_enable_audio) (BoxesDisplay* self, gboolean enable);
	gboolean (*should_keep_alive) (BoxesDisplay* self);
	void (*connect_it) (BoxesDisplay* self, BoxesDisplayOpenFDFunc open_fd, gpointer open_fd_target, GDestroyNotify open_fd_target_destroy_notify, GError** error);
	void (*disconnect_it) (BoxesDisplay* self);
	void (*collect_logs) (BoxesDisplay* self, GString* builder);
	void (*transfer_files) (BoxesDisplay* self, GList* uris);
	void (*send_keys) (BoxesDisplay* self, guint* keyvals, gint keyvals_length1);
	GList* (*get_properties) (BoxesDisplay* self, BoxesPropertiesPage page);
	const gchar* (*get_protocol) (BoxesDisplay* self);
	gchar* (*get_uri) (BoxesDisplay* self);
	gboolean (*get_can_transfer_files) (BoxesDisplay* self);
};

struct _BoxesDisplayPrivate {
	BoxesBoxConfig* _config;
	gboolean _can_grab_mouse;
	gboolean _mouse_grabbed;
	gboolean _keyboard_grabbed;
	gboolean _need_password;
	gboolean _need_username;
	gchar* _password;
	gchar* _username;
	gint64 started_time;
};

static gint BoxesDisplay_private_offset;
static gpointer boxes_display_parent_class = NULL;
static BoxesIPropertiesProviderIface * boxes_display_boxes_iproperties_provider_parent_iface = NULL;

GType boxes_properties_page_get_type (void) G_GNUC_CONST;
GType boxes_property_get_type (void) G_GNUC_CONST;
GType boxes_iproperties_provider_get_type (void) G_GNUC_CONST;
GType boxes_display_get_type (void) G_GNUC_CONST;
void boxes_display_access_finish (BoxesDisplay* self);
GtkWidget* boxes_display_get_display (BoxesDisplay* self,
                                      gint n);
static GtkWidget* boxes_display_real_get_display (BoxesDisplay* self,
                                           gint n);
GdkPixbuf* boxes_display_get_pixbuf (BoxesDisplay* self,
                                     gint n,
                                     GError** error);
static GdkPixbuf* boxes_display_real_get_pixbuf (BoxesDisplay* self,
                                          gint n,
                                          GError** error);
void boxes_display_set_enable_audio (BoxesDisplay* self,
                                     gboolean enable);
static void boxes_display_real_set_enable_audio (BoxesDisplay* self,
                                          gboolean enable);
gboolean boxes_display_should_keep_alive (BoxesDisplay* self);
static gboolean boxes_display_real_should_keep_alive (BoxesDisplay* self);
void boxes_display_connect_it (BoxesDisplay* self,
                               BoxesDisplayOpenFDFunc open_fd,
                               gpointer open_fd_target,
                               GDestroyNotify open_fd_target_destroy_notify,
                               GError** error);
static void boxes_display_real_connect_it (BoxesDisplay* self,
                                    BoxesDisplayOpenFDFunc open_fd,
                                    gpointer open_fd_target,
                                    GDestroyNotify open_fd_target_destroy_notify,
                                    GError** error);
void boxes_display_disconnect_it (BoxesDisplay* self);
static void boxes_display_real_disconnect_it (BoxesDisplay* self);
void boxes_display_collect_logs (BoxesDisplay* self,
                                 GString* builder);
static void boxes_display_real_collect_logs (BoxesDisplay* self,
                                      GString* builder);
void boxes_display_transfer_files (BoxesDisplay* self,
                                   GList* uris);
static void boxes_display_real_transfer_files (BoxesDisplay* self,
                                        GList* uris);
void boxes_display_send_keys (BoxesDisplay* self,
                              guint* keyvals,
                              gint keyvals_length1);
static void boxes_display_real_send_keys (BoxesDisplay* self,
                                   guint* keyvals,
                                   gint keyvals_length1);
GList* boxes_display_get_properties (BoxesDisplay* self,
                                     BoxesPropertiesPage page);
static GList* boxes_display_real_get_properties (BoxesDisplay* self,
                                          BoxesPropertiesPage page);
void boxes_display_access_start (BoxesDisplay* self);
BoxesBoxConfig* boxes_display_get_config (BoxesDisplay* self);
BoxesDisplay* boxes_display_construct (GType object_type);
const gchar* boxes_display_get_protocol (BoxesDisplay* self);
gchar* boxes_display_get_uri (BoxesDisplay* self);
gboolean boxes_display_get_can_transfer_files (BoxesDisplay* self);
void boxes_display_set_config (BoxesDisplay* self,
                               BoxesBoxConfig* value);
gboolean boxes_display_get_can_grab_mouse (BoxesDisplay* self);
void boxes_display_set_can_grab_mouse (BoxesDisplay* self,
                                       gboolean value);
gboolean boxes_display_get_mouse_grabbed (BoxesDisplay* self);
void boxes_display_set_mouse_grabbed (BoxesDisplay* self,
                                      gboolean value);
gboolean boxes_display_get_keyboard_grabbed (BoxesDisplay* self);
void boxes_display_set_keyboard_grabbed (BoxesDisplay* self,
                                         gboolean value);
gboolean boxes_display_get_need_password (BoxesDisplay* self);
void boxes_display_set_need_password (BoxesDisplay* self,
                                      gboolean value);
gboolean boxes_display_get_need_username (BoxesDisplay* self);
void boxes_display_set_need_username (BoxesDisplay* self,
                                      gboolean value);
const gchar* boxes_display_get_password (BoxesDisplay* self);
void boxes_display_set_password (BoxesDisplay* self,
                                 const gchar* value);
const gchar* boxes_display_get_username (BoxesDisplay* self);
void boxes_display_set_username (BoxesDisplay* self,
                                 const gchar* value);
static GObject * boxes_display_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static void boxes_display_finalize (GObject * obj);
static void _vala_boxes_display_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_boxes_display_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
boxes_display_get_instance_private (BoxesDisplay* self)
{
	return G_STRUCT_MEMBER_P (self, BoxesDisplay_private_offset);
}

static GtkWidget*
boxes_display_real_get_display (BoxesDisplay* self,
                                gint n)
{
#line 27 "../src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_get_display'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 27 "../src/display.vala"
	return NULL;
#line 235 "display.c"
}

GtkWidget*
boxes_display_get_display (BoxesDisplay* self,
                           gint n)
{
#line 27 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_display (self, n);
#line 246 "display.c"
}

static GdkPixbuf*
boxes_display_real_get_pixbuf (BoxesDisplay* self,
                               gint n,
                               GError** error)
{
#line 28 "../src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_get_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 28 "../src/display.vala"
	return NULL;
#line 258 "display.c"
}

GdkPixbuf*
boxes_display_get_pixbuf (BoxesDisplay* self,
                          gint n,
                          GError** error)
{
#line 28 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_pixbuf (self, n, error);
#line 270 "display.c"
}

static void
boxes_display_real_set_enable_audio (BoxesDisplay* self,
                                     gboolean enable)
{
#line 29 "../src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_set_enable_audio'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 29 "../src/display.vala"
	return;
#line 281 "display.c"
}

void
boxes_display_set_enable_audio (BoxesDisplay* self,
                                gboolean enable)
{
#line 29 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->set_enable_audio (self, enable);
#line 292 "display.c"
}

static gboolean
boxes_display_real_should_keep_alive (BoxesDisplay* self)
{
	gboolean result = FALSE;
#line 32 "../src/display.vala"
	result = FALSE;
#line 32 "../src/display.vala"
	return result;
#line 303 "display.c"
}

gboolean
boxes_display_should_keep_alive (BoxesDisplay* self)
{
#line 31 "../src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->should_keep_alive (self);
#line 313 "display.c"
}

static void
boxes_display_real_connect_it (BoxesDisplay* self,
                               BoxesDisplayOpenFDFunc open_fd,
                               gpointer open_fd_target,
                               GDestroyNotify open_fd_target_destroy_notify,
                               GError** error)
{
#line 35 "../src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_connect_it'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 35 "../src/display.vala"
	return;
#line 327 "display.c"
}

void
boxes_display_connect_it (BoxesDisplay* self,
                          BoxesDisplayOpenFDFunc open_fd,
                          gpointer open_fd_target,
                          GDestroyNotify open_fd_target_destroy_notify,
                          GError** error)
{
#line 35 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->connect_it (self, open_fd, open_fd_target, open_fd_target_destroy_notify, error);
#line 341 "display.c"
}

static void
boxes_display_real_disconnect_it (BoxesDisplay* self)
{
#line 36 "../src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_disconnect_it'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 36 "../src/display.vala"
	return;
#line 351 "display.c"
}

void
boxes_display_disconnect_it (BoxesDisplay* self)
{
#line 36 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->disconnect_it (self);
#line 361 "display.c"
}

static void
boxes_display_real_collect_logs (BoxesDisplay* self,
                                 GString* builder)
{
#line 38 "../src/display.vala"
	g_return_if_fail (builder != NULL);
#line 370 "display.c"
}

void
boxes_display_collect_logs (BoxesDisplay* self,
                            GString* builder)
{
#line 38 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->collect_logs (self, builder);
#line 381 "display.c"
}

static void
boxes_display_real_transfer_files (BoxesDisplay* self,
                                   GList* uris)
{
}

void
boxes_display_transfer_files (BoxesDisplay* self,
                              GList* uris)
{
#line 40 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->transfer_files (self, uris);
#line 398 "display.c"
}

static void
boxes_display_real_send_keys (BoxesDisplay* self,
                              guint* keyvals,
                              gint keyvals_length1)
{
#line 42 "../src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_send_keys'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 42 "../src/display.vala"
	return;
#line 410 "display.c"
}

void
boxes_display_send_keys (BoxesDisplay* self,
                         guint* keyvals,
                         gint keyvals_length1)
{
#line 42 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/display.vala"
	BOXES_DISPLAY_GET_CLASS (self)->send_keys (self, keyvals, keyvals_length1);
#line 422 "display.c"
}

static GList*
boxes_display_real_get_properties (BoxesDisplay* self,
                                   BoxesPropertiesPage page)
{
#line 44 "../src/display.vala"
	g_critical ("Type `%s' does not implement abstract method `boxes_display_get_properties'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 44 "../src/display.vala"
	return NULL;
#line 433 "display.c"
}

GList*
boxes_display_get_properties (BoxesDisplay* self,
                              BoxesPropertiesPage page)
{
#line 44 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_properties (self, page);
#line 444 "display.c"
}

void
boxes_display_access_start (BoxesDisplay* self)
{
	BoxesBoxConfig* _tmp0_;
	BoxesBoxConfig* _tmp1_;
	BoxesBoxConfig* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	BoxesBoxConfig* _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
#line 49 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/display.vala"
	if (self->priv->started_time != ((gint64) 0)) {
#line 51 "../src/display.vala"
		return;
#line 464 "display.c"
	}
#line 53 "../src/display.vala"
	self->priv->started_time = g_get_monotonic_time ();
#line 54 "../src/display.vala"
	_tmp0_ = self->priv->_config;
#line 54 "../src/display.vala"
	boxes_box_config_set_access_last_time (_tmp0_, g_get_real_time ());
#line 55 "../src/display.vala"
	_tmp1_ = self->priv->_config;
#line 55 "../src/display.vala"
	_tmp2_ = self->priv->_config;
#line 55 "../src/display.vala"
	_tmp3_ = boxes_box_config_get_access_ntimes (_tmp2_);
#line 55 "../src/display.vala"
	_tmp4_ = _tmp3_;
#line 55 "../src/display.vala"
	boxes_box_config_set_access_ntimes (_tmp2_, _tmp4_ + 1);
#line 57 "../src/display.vala"
	_tmp5_ = self->priv->_config;
#line 57 "../src/display.vala"
	_tmp6_ = boxes_box_config_get_access_first_time (_tmp5_);
#line 57 "../src/display.vala"
	_tmp7_ = _tmp6_;
#line 57 "../src/display.vala"
	if (_tmp7_ == ((gint64) 0)) {
#line 490 "display.c"
		BoxesBoxConfig* _tmp8_;
		BoxesBoxConfig* _tmp9_;
		gint64 _tmp10_;
		gint64 _tmp11_;
#line 58 "../src/display.vala"
		_tmp8_ = self->priv->_config;
#line 58 "../src/display.vala"
		_tmp9_ = self->priv->_config;
#line 58 "../src/display.vala"
		_tmp10_ = boxes_box_config_get_access_last_time (_tmp9_);
#line 58 "../src/display.vala"
		_tmp11_ = _tmp10_;
#line 58 "../src/display.vala"
		boxes_box_config_set_access_first_time (_tmp8_, _tmp11_);
#line 505 "display.c"
	}
}

void
boxes_display_access_finish (BoxesDisplay* self)
{
	gint64 duration = 0LL;
	BoxesBoxConfig* _tmp0_;
	BoxesBoxConfig* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
#line 61 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/display.vala"
	if (self->priv->started_time == ((gint64) 0)) {
#line 63 "../src/display.vala"
		return;
#line 523 "display.c"
	}
#line 65 "../src/display.vala"
	duration = g_get_monotonic_time () - self->priv->started_time;
#line 66 "../src/display.vala"
	duration = duration / 1000000;
#line 67 "../src/display.vala"
	_tmp0_ = self->priv->_config;
#line 67 "../src/display.vala"
	_tmp1_ = self->priv->_config;
#line 67 "../src/display.vala"
	_tmp2_ = boxes_box_config_get_access_total_time (_tmp1_);
#line 67 "../src/display.vala"
	_tmp3_ = _tmp2_;
#line 67 "../src/display.vala"
	boxes_box_config_set_access_total_time (_tmp1_, _tmp3_ + duration);
#line 69 "../src/display.vala"
	self->priv->started_time = (gint64) 0;
#line 541 "display.c"
}

BoxesDisplay*
boxes_display_construct (GType object_type)
{
	BoxesDisplay * self = NULL;
#line 4 "../src/display.vala"
	self = (BoxesDisplay*) g_object_new (object_type, NULL);
#line 4 "../src/display.vala"
	return self;
#line 552 "display.c"
}

const gchar*
boxes_display_get_protocol (BoxesDisplay* self)
{
#line 5 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5 "../src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_protocol (self);
#line 562 "display.c"
}

gchar*
boxes_display_get_uri (BoxesDisplay* self)
{
#line 6 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6 "../src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_uri (self);
#line 572 "display.c"
}

gboolean
boxes_display_get_can_transfer_files (BoxesDisplay* self)
{
#line 7 "../src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7 "../src/display.vala"
	return BOXES_DISPLAY_GET_CLASS (self)->get_can_transfer_files (self);
#line 582 "display.c"
}

static gboolean
boxes_display_real_get_can_transfer_files (BoxesDisplay* base)
{
	gboolean result;
	BoxesDisplay* self;
#line 7 "../src/display.vala"
	self = base;
#line 7 "../src/display.vala"
	result = FALSE;
#line 7 "../src/display.vala"
	return result;
#line 596 "display.c"
}

BoxesBoxConfig*
boxes_display_get_config (BoxesDisplay* self)
{
	BoxesBoxConfig* result;
	BoxesBoxConfig* _tmp0_;
#line 9 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../src/display.vala"
	_tmp0_ = self->priv->_config;
#line 9 "../src/display.vala"
	result = _tmp0_;
#line 9 "../src/display.vala"
	return result;
#line 612 "display.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 9 "../src/display.vala"
	return self ? g_object_ref (self) : NULL;
#line 620 "display.c"
}

void
boxes_display_set_config (BoxesDisplay* self,
                          BoxesBoxConfig* value)
{
#line 9 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/display.vala"
	if (boxes_display_get_config (self) != value) {
#line 631 "display.c"
		BoxesBoxConfig* _tmp0_;
#line 9 "../src/display.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 9 "../src/display.vala"
		_g_object_unref0 (self->priv->_config);
#line 9 "../src/display.vala"
		self->priv->_config = _tmp0_;
#line 9 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_CONFIG_PROPERTY]);
#line 641 "display.c"
	}
}

gboolean
boxes_display_get_can_grab_mouse (BoxesDisplay* self)
{
	gboolean result;
#line 10 "../src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 10 "../src/display.vala"
	result = self->priv->_can_grab_mouse;
#line 10 "../src/display.vala"
	return result;
#line 655 "display.c"
}

void
boxes_display_set_can_grab_mouse (BoxesDisplay* self,
                                  gboolean value)
{
#line 10 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/display.vala"
	if (boxes_display_get_can_grab_mouse (self) != value) {
#line 10 "../src/display.vala"
		self->priv->_can_grab_mouse = value;
#line 10 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY]);
#line 670 "display.c"
	}
}

gboolean
boxes_display_get_mouse_grabbed (BoxesDisplay* self)
{
	gboolean result;
#line 11 "../src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 11 "../src/display.vala"
	result = self->priv->_mouse_grabbed;
#line 11 "../src/display.vala"
	return result;
#line 684 "display.c"
}

void
boxes_display_set_mouse_grabbed (BoxesDisplay* self,
                                 gboolean value)
{
#line 11 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/display.vala"
	if (boxes_display_get_mouse_grabbed (self) != value) {
#line 11 "../src/display.vala"
		self->priv->_mouse_grabbed = value;
#line 11 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY]);
#line 699 "display.c"
	}
}

gboolean
boxes_display_get_keyboard_grabbed (BoxesDisplay* self)
{
	gboolean result;
#line 12 "../src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12 "../src/display.vala"
	result = self->priv->_keyboard_grabbed;
#line 12 "../src/display.vala"
	return result;
#line 713 "display.c"
}

void
boxes_display_set_keyboard_grabbed (BoxesDisplay* self,
                                    gboolean value)
{
#line 12 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/display.vala"
	if (boxes_display_get_keyboard_grabbed (self) != value) {
#line 12 "../src/display.vala"
		self->priv->_keyboard_grabbed = value;
#line 12 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY]);
#line 728 "display.c"
	}
}

gboolean
boxes_display_get_need_password (BoxesDisplay* self)
{
	gboolean result;
#line 13 "../src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 13 "../src/display.vala"
	result = self->priv->_need_password;
#line 13 "../src/display.vala"
	return result;
#line 742 "display.c"
}

void
boxes_display_set_need_password (BoxesDisplay* self,
                                 gboolean value)
{
#line 13 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/display.vala"
	if (boxes_display_get_need_password (self) != value) {
#line 13 "../src/display.vala"
		self->priv->_need_password = value;
#line 13 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_NEED_PASSWORD_PROPERTY]);
#line 757 "display.c"
	}
}

gboolean
boxes_display_get_need_username (BoxesDisplay* self)
{
	gboolean result;
#line 14 "../src/display.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 14 "../src/display.vala"
	result = self->priv->_need_username;
#line 14 "../src/display.vala"
	return result;
#line 771 "display.c"
}

void
boxes_display_set_need_username (BoxesDisplay* self,
                                 gboolean value)
{
#line 14 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/display.vala"
	if (boxes_display_get_need_username (self) != value) {
#line 14 "../src/display.vala"
		self->priv->_need_username = value;
#line 14 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_NEED_USERNAME_PROPERTY]);
#line 786 "display.c"
	}
}

const gchar*
boxes_display_get_password (BoxesDisplay* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 15 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/display.vala"
	_tmp0_ = self->priv->_password;
#line 15 "../src/display.vala"
	result = _tmp0_;
#line 15 "../src/display.vala"
	return result;
#line 803 "display.c"
}

void
boxes_display_set_password (BoxesDisplay* self,
                            const gchar* value)
{
#line 15 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/display.vala"
	if (g_strcmp0 (value, boxes_display_get_password (self)) != 0) {
#line 814 "display.c"
		gchar* _tmp0_;
#line 15 "../src/display.vala"
		_tmp0_ = g_strdup (value);
#line 15 "../src/display.vala"
		_g_free0 (self->priv->_password);
#line 15 "../src/display.vala"
		self->priv->_password = _tmp0_;
#line 15 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_PASSWORD_PROPERTY]);
#line 824 "display.c"
	}
}

const gchar*
boxes_display_get_username (BoxesDisplay* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 16 "../src/display.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../src/display.vala"
	_tmp0_ = self->priv->_username;
#line 16 "../src/display.vala"
	result = _tmp0_;
#line 16 "../src/display.vala"
	return result;
#line 841 "display.c"
}

void
boxes_display_set_username (BoxesDisplay* self,
                            const gchar* value)
{
#line 16 "../src/display.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/display.vala"
	if (g_strcmp0 (value, boxes_display_get_username (self)) != 0) {
#line 852 "display.c"
		gchar* _tmp0_;
#line 16 "../src/display.vala"
		_tmp0_ = g_strdup (value);
#line 16 "../src/display.vala"
		_g_free0 (self->priv->_username);
#line 16 "../src/display.vala"
		self->priv->_username = _tmp0_;
#line 16 "../src/display.vala"
		g_object_notify_by_pspec ((GObject *) self, boxes_display_properties[BOXES_DISPLAY_USERNAME_PROPERTY]);
#line 862 "display.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 77 "../src/display.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 871 "display.c"
}

static GObject *
boxes_display_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BoxesDisplay * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 76 "../src/display.vala"
	parent_class = G_OBJECT_CLASS (boxes_display_parent_class);
#line 76 "../src/display.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 76 "../src/display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 77 "../src/display.vala"
	_tmp0_ = g_direct_hash;
#line 77 "../src/display.vala"
	_tmp1_ = g_direct_equal;
#line 77 "../src/display.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_object_unref0_);
#line 77 "../src/display.vala"
	_g_hash_table_unref0 (self->displays);
#line 77 "../src/display.vala"
	self->displays = _tmp2_;
#line 76 "../src/display.vala"
	return obj;
#line 903 "display.c"
}

static void
boxes_display_class_init (BoxesDisplayClass * klass,
                          gpointer klass_data)
{
#line 4 "../src/display.vala"
	boxes_display_parent_class = g_type_class_peek_parent (klass);
#line 4 "../src/display.vala"
	g_type_class_adjust_private_offset (klass, &BoxesDisplay_private_offset);
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->get_display = (GtkWidget* (*) (BoxesDisplay*, gint)) boxes_display_real_get_display;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (BoxesDisplay*, gint, GError**)) boxes_display_real_get_pixbuf;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->set_enable_audio = (void (*) (BoxesDisplay*, gboolean)) boxes_display_real_set_enable_audio;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->should_keep_alive = (gboolean (*) (BoxesDisplay*)) boxes_display_real_should_keep_alive;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->connect_it = (void (*) (BoxesDisplay*, BoxesDisplayOpenFDFunc, gpointer, GDestroyNotify, GError**)) boxes_display_real_connect_it;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->disconnect_it = (void (*) (BoxesDisplay*)) boxes_display_real_disconnect_it;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->collect_logs = (void (*) (BoxesDisplay*, GString*)) boxes_display_real_collect_logs;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->transfer_files = (void (*) (BoxesDisplay*, GList*)) boxes_display_real_transfer_files;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->send_keys = (void (*) (BoxesDisplay*, guint*, gint)) boxes_display_real_send_keys;
#line 4 "../src/display.vala"
	((BoxesDisplayClass *) klass)->get_properties = (GList* (*) (BoxesDisplay*, BoxesPropertiesPage)) boxes_display_real_get_properties;
#line 4 "../src/display.vala"
	BOXES_DISPLAY_CLASS (klass)->get_can_transfer_files = boxes_display_real_get_can_transfer_files;
#line 4 "../src/display.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_display_get_property;
#line 4 "../src/display.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_boxes_display_set_property;
#line 4 "../src/display.vala"
	G_OBJECT_CLASS (klass)->constructor = boxes_display_constructor;
#line 4 "../src/display.vala"
	G_OBJECT_CLASS (klass)->finalize = boxes_display_finalize;
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_PROTOCOL_PROPERTY, boxes_display_properties[BOXES_DISPLAY_PROTOCOL_PROPERTY] = g_param_spec_string ("protocol", "protocol", "protocol", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_URI_PROPERTY, boxes_display_properties[BOXES_DISPLAY_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_CAN_TRANSFER_FILES_PROPERTY, boxes_display_properties[BOXES_DISPLAY_CAN_TRANSFER_FILES_PROPERTY] = g_param_spec_boolean ("can-transfer-files", "can-transfer-files", "can-transfer-files", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_CONFIG_PROPERTY, boxes_display_properties[BOXES_DISPLAY_CONFIG_PROPERTY] = g_param_spec_object ("config", "config", "config", BOXES_TYPE_BOX_CONFIG, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY, boxes_display_properties[BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY] = g_param_spec_boolean ("can-grab-mouse", "can-grab-mouse", "can-grab-mouse", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY, boxes_display_properties[BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY] = g_param_spec_boolean ("mouse-grabbed", "mouse-grabbed", "mouse-grabbed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY, boxes_display_properties[BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY] = g_param_spec_boolean ("keyboard-grabbed", "keyboard-grabbed", "keyboard-grabbed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_NEED_PASSWORD_PROPERTY, boxes_display_properties[BOXES_DISPLAY_NEED_PASSWORD_PROPERTY] = g_param_spec_boolean ("need-password", "need-password", "need-password", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_NEED_USERNAME_PROPERTY, boxes_display_properties[BOXES_DISPLAY_NEED_USERNAME_PROPERTY] = g_param_spec_boolean ("need-username", "need-username", "need-username", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_PASSWORD_PROPERTY, boxes_display_properties[BOXES_DISPLAY_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_DISPLAY_USERNAME_PROPERTY, boxes_display_properties[BOXES_DISPLAY_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "../src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_SHOW_SIGNAL] = g_signal_new ("show", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 4 "../src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_HIDE_SIGNAL] = g_signal_new ("hide", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 4 "../src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_DISCONNECTED_SIGNAL] = g_signal_new ("disconnected", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 4 "../src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_GOT_ERROR_SIGNAL] = g_signal_new ("got-error", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 4 "../src/display.vala"
	boxes_display_signals[BOXES_DISPLAY_AUTH_FAILED_SIGNAL] = g_signal_new ("auth-failed", BOXES_TYPE_DISPLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 976 "display.c"
}

static void
boxes_display_boxes_iproperties_provider_interface_init (BoxesIPropertiesProviderIface * iface,
                                                         gpointer iface_data)
{
#line 4 "../src/display.vala"
	boxes_display_boxes_iproperties_provider_parent_iface = g_type_interface_peek_parent (iface);
#line 4 "../src/display.vala"
	iface->get_properties = (GList* (*) (BoxesIPropertiesProvider*, BoxesPropertiesPage)) boxes_display_get_properties;
#line 987 "display.c"
}

static void
boxes_display_instance_init (BoxesDisplay * self,
                             gpointer klass)
{
#line 4 "../src/display.vala"
	self->priv = boxes_display_get_instance_private (self);
#line 996 "display.c"
}

static void
boxes_display_finalize (GObject * obj)
{
	BoxesDisplay * self;
#line 4 "../src/display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 73 "../src/display.vala"
	boxes_display_access_finish (self);
#line 9 "../src/display.vala"
	_g_object_unref0 (self->priv->_config);
#line 15 "../src/display.vala"
	_g_free0 (self->priv->_password);
#line 16 "../src/display.vala"
	_g_free0 (self->priv->_username);
#line 46 "../src/display.vala"
	_g_hash_table_unref0 (self->displays);
#line 4 "../src/display.vala"
	G_OBJECT_CLASS (boxes_display_parent_class)->finalize (obj);
#line 1017 "display.c"
}

GType
boxes_display_get_type (void)
{
	static volatile gsize boxes_display_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_display_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesDisplay), 0, (GInstanceInitFunc) boxes_display_instance_init, NULL };
		static const GInterfaceInfo boxes_iproperties_provider_info = { (GInterfaceInitFunc) boxes_display_boxes_iproperties_provider_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType boxes_display_type_id;
		boxes_display_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesDisplay", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (boxes_display_type_id, BOXES_TYPE_IPROPERTIES_PROVIDER, &boxes_iproperties_provider_info);
		BoxesDisplay_private_offset = g_type_add_instance_private (boxes_display_type_id, sizeof (BoxesDisplayPrivate));
		g_once_init_leave (&boxes_display_type_id__volatile, boxes_display_type_id);
	}
	return boxes_display_type_id__volatile;
}

static void
_vala_boxes_display_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	BoxesDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 4 "../src/display.vala"
	switch (property_id) {
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_CAN_TRANSFER_FILES_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_boolean (value, boxes_display_get_can_transfer_files (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_CONFIG_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_object (value, boxes_display_get_config (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_boolean (value, boxes_display_get_can_grab_mouse (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_boolean (value, boxes_display_get_mouse_grabbed (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_boolean (value, boxes_display_get_keyboard_grabbed (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_NEED_PASSWORD_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_boolean (value, boxes_display_get_need_password (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_NEED_USERNAME_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_boolean (value, boxes_display_get_need_username (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_PASSWORD_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_string (value, boxes_display_get_password (self));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_USERNAME_PROPERTY:
#line 4 "../src/display.vala"
		g_value_set_string (value, boxes_display_get_username (self));
#line 4 "../src/display.vala"
		break;
#line 1100 "display.c"
		default:
#line 4 "../src/display.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "../src/display.vala"
		break;
#line 1106 "display.c"
	}
}

static void
_vala_boxes_display_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	BoxesDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_DISPLAY, BoxesDisplay);
#line 4 "../src/display.vala"
	switch (property_id) {
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_CONFIG_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_config (self, g_value_get_object (value));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_CAN_GRAB_MOUSE_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_can_grab_mouse (self, g_value_get_boolean (value));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_MOUSE_GRABBED_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_mouse_grabbed (self, g_value_get_boolean (value));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_KEYBOARD_GRABBED_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_keyboard_grabbed (self, g_value_get_boolean (value));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_NEED_PASSWORD_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_need_password (self, g_value_get_boolean (value));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_NEED_USERNAME_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_need_username (self, g_value_get_boolean (value));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_PASSWORD_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_password (self, g_value_get_string (value));
#line 4 "../src/display.vala"
		break;
#line 4 "../src/display.vala"
		case BOXES_DISPLAY_USERNAME_PROPERTY:
#line 4 "../src/display.vala"
		boxes_display_set_username (self, g_value_get_string (value));
#line 4 "../src/display.vala"
		break;
#line 1168 "display.c"
		default:
#line 4 "../src/display.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "../src/display.vala"
		break;
#line 1174 "display.c"
	}
}

